﻿using System;
using System.Data.SqlServerCe;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CDP_Utils;
using log4net;

namespace CDP_Database
{


    //public class cDBConnection
    //{
    //    public static SqlCeConnection getConnection(ref string ErrMsg)
    //    {
    //        ErrMsg = string.Empty;
    //        string dbPassword = string.Empty;
    //        string connString = string.Empty;
    //        SqlCeConnection conn = null;

    //        try
    //        {
    //            dbPassword = cApplicationConfiguration.getDecryptedAppSettings("dbPassword", ref ErrMsg);
    //            connString = cApplicationConfiguration.getConnectionString("dbConnectionString", ref ErrMsg);
    //            connString += ";Password=" + dbPassword;
    //            conn = new SqlCeConnection(connString);
    //        }
    //        catch (Exception ex)
    //        {
    //            ErrMsg = ex.Message;
    //        }

    //        return conn;
    //    }

    //}


    public sealed class cDBConnection
    {
        // Create a logger for use in this class
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        private static readonly cDBConnection instance = new cDBConnection();
        private readonly SqlCeConnection con = new SqlCeConnection();
        //private readonly SqlCeConnection con;

        // Explicit static constructor to tell C# compiler
        // not to mark type as beforefieldinit
        static cDBConnection()
        {
        }

        private cDBConnection()
        {

            //TODO open connection here
        }

        public static cDBConnection Instance
        {
            get
            {
                if (log.IsInfoEnabled) log.Info("Get cDBConnection.Instance");
                return instance;
            }
        }

        public SqlCeConnection getConnection()
        {
            string dbPassword = string.Empty;
            string connString = string.Empty;

            try
            {
                dbPassword = cApplicationConfiguration.getDecryptedAppSettings("dbPassword");
                connString = cApplicationConfiguration.getConnectionString("dbConnectionString");
                connString += ";Password=" + dbPassword;
                con.ConnectionString = connString;
            }
            catch (Exception ex)
            {
                cErrorHandling.fErrorMessage("Error connecting to the database !");
                if (log.IsErrorEnabled) log.Error("Error connecting to the database",ex);
            }

            if (log.IsInfoEnabled) log.Info("Get SqlCeConnection");
            return con;
        }
    }
}
